mod turtle;

use turtle::{defaults, Turtle};

#[allow(dead_code)]
fn square() {
    let mut turtle = Turtle::new();
    let default_pos = defaults::position();
    let steps_count = 20;

    turtle.set_pos((
        default_pos.0 - (turtle.step_length() * steps_count / 2) as i32, 
        default_pos.1 + (turtle.step_length() * steps_count / 2) as i32
    ));

    turtle.left_forward(90.0, steps_count);
    for _ in 0..3 {
        turtle.right_forward(90.0, steps_count);
    }
    turtle.save("imgs/square.png").unwrap();
}

#[allow(dead_code)]
fn circle() {
    let mut turtle = Turtle::new();
    let default_pos = defaults::position();

    let circumference = (36 * 2 * defaults::STEP_LENGTH) as f64;
    let radius = circumference / (2.0 * std::f64::consts::PI);

    turtle.set_pos((
        default_pos.0 - (turtle.step_length() * 2 / 2) as i32,
        default_pos.1 - radius as i32
    ));
    
    for _ in 0..36 {
        turtle.forward_right(2, 10.0);
    }
    turtle.save("imgs/circle.png").unwrap();
}

fn main() {
    square();
    circle();
}
